# MSWord Document Product for Zope - MSWord.py
# Copyright (C) 2001 ric BARROCA <eric@barroca.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# MSWord.py : Python module providing an interface to convert
#			  MSWord documents into HTML documents using vwWare (formerly
#			  called mswordview).
#
# Variables :
#	- data (string) : contains the MSWord Document (usualy got from a 
#					  "data = file.read()")
#	- name (string) : the document's filename

import re, os, tempfile

HREF = re.compile("(>)(http://.*?)(<)", re.DOTALL)
IMG = re.compile("(.*?)(<img src=)(.*?)(>)(.*)", re.DOTALL + re.MULTILINE + re.IGNORECASE)
BODY = re.compile("(.*?)(<body>)(.*)", re.DOTALL + re.MULTILINE + re.IGNORECASE)
BODY_end = re.compile("(.*)(</body>)(.*?)", re.DOTALL + re.MULTILINE + re.IGNORECASE)
FONT = re.compile("<font([^>]+)></font>", re.DOTALL + re.MULTILINE + re.IGNORECASE)

class RTFDoc:

	def __init__(self, name, data):
		"Initialization : create tmp work directory and copy the document into a file."
		self.prefix = "/home/iii_server/zope/lib/python/Products/RTFDocument/rtf2html"
		# The path prefix where wvWare ist installed (usualy /usr or /usr/local)
		self.html = None
		self.tmpdir = tempfile.mktemp()
		self.name = name
		self.data = data
		os.mkdir('%s' % self.tmpdir)
		filedest = open("%s/%s.rtf" % (self.tmpdir, self.name), "w")
		filedest.write(self.data)
		filedest.close()
	
	def Convert(self):
		"Convert the document"
		os.system('cd "%s" && %s/rtf2htm --simple "%s.rtf" > "%s.html"' % (self.tmpdir, self.prefix, self.name, self.name))

	def cleandir(self):
		for i in os.listdir("%s" % self.tmpdir):
			os.remove("%s/%s" % (self.tmpdir, i))
		os.rmdir("%s" % self.tmpdir)
	
	def getDocHTML(self):
		html = open("%s/%s.html" % (self.tmpdir, self.name)).read()
		
		# Convert http stuff to a hyper link
		self.html = html
		
		# Strip off the top and bottom html
		self.html = BODY.match(self.html).groups()[2]
		self.html = BODY_end.match(self.html).groups()[0]

		temp = None

		# Remove double font tags
		while self.html != temp:
			temp = self.html
			self.html = FONT.sub('', self.html)

		# Do link to <a href links
		self.html = HREF.sub(r"><a href='\2'>\2</a><", self.html)
		return self.html

	def getImgs(self):
		imgs = {}

		if self.html == None:
			self.getDocHTML

		html = self.html

		endbit = html
		matches = []
		complete = ""

		while matches != None:
			try:
				matches = IMG.match (endbit).groups()
				endbit = matches[-1]
				os.system('export PATH=$PATH:/home/iii_server/programs/bin && cd "%s" && convert "%s" "%s"' % (self.tmpdir, matches[2], matches[2] + '.png'))
				try:
					imgs[matches[2] + '.png'] = open("%s/%s" % (self.tmpdir, matches[2] + '.png')).read()
				except IOError:
					pass
				complete = complete + matches[0] + matches[1] + '"' + matches[2] + '.png' + '"' + matches[3]
			except:
				matches = None

		complete = complete + endbit

#		# Get the html documents and see if the document contained images... if so convert them to pngs...
#		for i in os.listdir("%s" % self.tmpdir):
#			result = re.match("^.+\.(?P<ext>.+)$", i)
#			if result is not None:
#				ext = result.group('ext') 
#				if ext in ("png", "jpg", "gif"):
#					imgs[i] = open("%s/%s" % (self.tmpdir, i)).read()
		return complete, imgs
